#!/usr/bin/env node
'use strict';

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _CommandExecutionService = require('../services/CommandExecutionService');

var _CommandExecutionService2 = _interopRequireDefault(_CommandExecutionService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var service = new _CommandExecutionService2.default();

_commander2.default.option('-s, --start <start>', 'specify start address').option('-e, --end <end>', 'specify end address').parse(process.argv);

if (_commander2.default.end === undefined) {
  console.error('Please provide a destination address!');
  process.exit(1);
}

try {
  service.executeRideEstimates(_commander2.default.start, _commander2.default.end).then(function (table) {
    return console.log(table);
  });
} catch (error) {
  console.error('Could not get estimated prices');
}