'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

// import DistanceUnit from '../data/DistanceUnit';


var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _LyftService = require('./LyftService');

var _LyftService2 = _interopRequireDefault(_LyftService);

var _RideEstimateQuery = require('../data/RideEstimateQuery');

var _RideEstimateQuery2 = _interopRequireDefault(_RideEstimateQuery);

var _RideTypesTableBuilder = require('./tables/builders/RideTypesTableBuilder');

var _RideTypesTableBuilder2 = _interopRequireDefault(_RideTypesTableBuilder);

var _NearbyDriversTableBuilder = require('./tables/builders/NearbyDriversTableBuilder');

var _NearbyDriversTableBuilder2 = _interopRequireDefault(_NearbyDriversTableBuilder);

var _DriverEtasTableBuilder = require('./tables/builders/DriverEtasTableBuilder');

var _DriverEtasTableBuilder2 = _interopRequireDefault(_DriverEtasTableBuilder);

var _RideEstimatesTableBuilder = require('./tables/builders/RideEstimatesTableBuilder');

var _RideEstimatesTableBuilder2 = _interopRequireDefault(_RideEstimatesTableBuilder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CommandExecutionService = function () {
  function CommandExecutionService() {
    _classCallCheck(this, CommandExecutionService);

    this.lyftService = new _LyftService2.default();
  }

  _createClass(CommandExecutionService, [{
    key: 'executeRideTypes',
    value: function executeRideTypes(address) {
      // if (typeof address !== 'string') {
      //   throw new TypeError('address should be a string');
      // }

      return this.lyftService.getRideTypes(address).then(function (rideTypes) {
        return _RideTypesTableBuilder2.default.build(rideTypes);
      });
    }
  }, {
    key: 'executeDriverEtas',
    value: function executeDriverEtas(address) {
      // if (typeof address !== 'string') {
      //   throw new TypeError('address should be a string');
      // }

      return this.lyftService.getDriverEtas(address).then(function (driverEtas) {
        return _DriverEtasTableBuilder2.default.build(driverEtas);
      });
    }
  }, {
    key: 'executeRideEstimates',
    value: function executeRideEstimates(startAddress, endAddress) {
      // if (typeof startAddress !== 'string') {
      //   throw new TypeError('start address should be a string');
      // }

      if (typeof endAddress !== 'string') {
        throw new TypeError('end address should be a string');
      }

      var addresses = _RideEstimateQuery2.default.from(startAddress, endAddress);

      return this.lyftService.getRideEstimates(addresses).then(function (rideEstimates) {
        return _RideEstimatesTableBuilder2.default.build(rideEstimates);
      });
    }
  }, {
    key: 'executeNearbyDrivers',
    value: function executeNearbyDrivers(address) {
      // if (typeof address !== 'string') {
      //   throw new TypeError('address should be a string');
      // }

      return this.lyftService.getNearbyDrivers(address).then(function (nearbyDrivers) {
        return _NearbyDriversTableBuilder2.default.build(nearbyDrivers);
      });
    }
  }]);

  return CommandExecutionService;
}();

exports.default = CommandExecutionService;