'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _convertUnits = require('convert-units');

var _convertUnits2 = _interopRequireDefault(_convertUnits);

var _Duration = require('../data/Duration');

var _Duration2 = _interopRequireDefault(_Duration);

var _TimeUnit = require('../data/TimeUnit');

var _TimeUnit2 = _interopRequireDefault(_TimeUnit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DurationConverter = function () {
  function DurationConverter() {
    _classCallCheck(this, DurationConverter);
  }

  _createClass(DurationConverter, null, [{
    key: 'convert',
    value: function convert(duration, toUnit) {
      var fromUnitIdentifier = DurationConverter.getUnitConversionIdentifier(duration.unit);
      var toUnitIdentifier = DurationConverter.getUnitConversionIdentifier(toUnit);
      var convertedLength = (0, _convertUnits2.default)(duration.length).from(fromUnitIdentifier).to(toUnitIdentifier);
      return new _Duration2.default({
        length: convertedLength,
        unit: toUnit
      });
    }
  }, {
    key: 'getUnitConversionIdentifier',
    value: function getUnitConversionIdentifier(unit) {
      switch (unit) {
        case _TimeUnit2.default.SECOND:
          {
            return 's';
          }

        case _TimeUnit2.default.MINUTE:
          {
            return 'min';
          }

        default:
          {
            throw new TypeError('Unknown unit');
          }
      }
    }
  }]);

  return DurationConverter;
}();

exports.default = DurationConverter;