'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Distance = require('../../data/Distance');

var _Distance2 = _interopRequireDefault(_Distance);

var _DistanceUnit = require('../../data/DistanceUnit');

var _DistanceUnit2 = _interopRequireDefault(_DistanceUnit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DistanceCalculator = function () {
  function DistanceCalculator() {
    _classCallCheck(this, DistanceCalculator);
  }

  _createClass(DistanceCalculator, null, [{
    key: 'calculateDistance',


    // http://www.geodatasource.com/developers/javascript
    value: function calculateDistance(start, end) {
      var unit = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _DistanceUnit2.default.MILE;


      var radlat1 = Math.PI * start.latitude / 180;
      var radlat2 = Math.PI * end.latitude / 180;
      var theta = start.longitude - end.longitude;
      var radtheta = Math.PI * theta / 180;
      var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
      dist = Math.acos(dist);
      dist = dist * 180 / Math.PI;
      dist = dist * 60 * 1.1515;
      if (unit === "KILOMETER") {
        dist *= 1.609344;
      }

      return new _Distance2.default({
        value: dist,
        unit: unit
      });
    }
  }]);

  return DistanceCalculator;
}();

exports.default = DistanceCalculator;