'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _convertUnits = require('convert-units');

var _convertUnits2 = _interopRequireDefault(_convertUnits);

var _Distance = require('../../data/Distance');

var _Distance2 = _interopRequireDefault(_Distance);

var _DistanceUnit = require('../../data/DistanceUnit');

var _DistanceUnit2 = _interopRequireDefault(_DistanceUnit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DistanceConverter = function () {
  function DistanceConverter() {
    _classCallCheck(this, DistanceConverter);
  }

  _createClass(DistanceConverter, null, [{
    key: 'convert',
    value: function convert(distance, toUnit) {
      var fromUnitIdentifier = DistanceConverter.getUnitConversionIdentifier(distance.unit);
      var toUnitIdentifier = DistanceConverter.getUnitConversionIdentifier(toUnit);
      var convertedValue = (0, _convertUnits2.default)(distance.value).from(fromUnitIdentifier).to(toUnitIdentifier);

      switch (toUnit) {
        case _DistanceUnit2.default.KILOMETER:
          {
            // Note divided by 1000 because convert library does not have kilometers, so using meters
            return new _Distance2.default({
              value: convertedValue / 1000,
              unit: _DistanceUnit2.default.KILOMETER
            });
          }

        case _DistanceUnit2.default.MILE:
          {
            return new _Distance2.default({
              value: convertedValue,
              unit: _DistanceUnit2.default.MILE
            });
          }

        default:
          {
            throw new TypeError('Unexpected Unit');
          }
      }
    }
  }, {
    key: 'getUnitConversionIdentifier',
    value: function getUnitConversionIdentifier(unit) {
      switch (unit) {
        case _DistanceUnit2.default.MILE:
          {
            return 'mi';
          }

        case _DistanceUnit2.default.KILOMETER:
          {
            return 'm';
          }

        default:
          {
            throw new TypeError('Unknown unit');
          }
      }
    }
  }]);

  return DistanceConverter;
}();

exports.default = DistanceConverter;