'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

// import DistanceCalculator from '../../calculators/DistanceCalculator';

var _nodeEmoji = require('node-emoji');

var _nodeEmoji2 = _interopRequireDefault(_nodeEmoji);

var _immutable = require('immutable');

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _DriverEtaFormatter = require('../formatters/DriverEtaFormatter');

var _DriverEtaFormatter2 = _interopRequireDefault(_DriverEtaFormatter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DriverEtasTableBuilder = function () {
  function DriverEtasTableBuilder() {
    _classCallCheck(this, DriverEtasTableBuilder);
  }

  _createClass(DriverEtasTableBuilder, null, [{
    key: 'build',
    value: function build(driverEtas) {
      var table = DriverEtasTableBuilder.buildInitialTable(driverEtas.location.name);

      var driverEtaRows = driverEtas.driverEtas.map(function (driverEta) {
        return DriverEtasTableBuilder.buildDriverEtaRow(driverEta);
      });

      driverEtaRows = driverEtaRows.sort(DriverEtasTableBuilder.sortByDisplayName);

      driverEtaRows.forEach(function (driverEtaRow) {
        table.push(driverEtaRow);
      });

      return table.toString();
    }
  }, {
    key: 'getTableHeaders',
    value: function getTableHeaders() {
      return _immutable.List.of(_nodeEmoji2.default.get('red_car'), _nodeEmoji2.default.get('timer_clock'));
    }
  }, {
    key: 'buildInitialTable',
    value: function buildInitialTable(locationName) {
      var table = new _cliTable2.default();
      table.push([{
        colSpan: 2,
        content: _nodeEmoji2.default.get('round_pushpin') + ' ' + locationName,
        hAlign: 'center'
      }]);
      var formattedHeaders = (0, _immutable.List)(DriverEtasTableBuilder.getTableHeaders().map(function (header) {
        return (0, _immutable.Map)({ content: header, hAlign: 'center' });
      }));
      table.push(formattedHeaders.toJS());
      return table;
    }
  }, {
    key: 'buildDriverEtaRow',
    value: function buildDriverEtaRow(driverEta) {
      // TODO: Check for driverEta.isValidEstimate
      return [driverEta.displayName, DriverEtasTableBuilder.buildDuration(_DriverEtaFormatter2.default.formatDuration(driverEta.etaSeconds)).toJS()];
    }
  }, {
    key: 'buildDuration',
    value: function buildDuration(duration) {
      return (0, _immutable.Map)({
        content: duration,
        hAlign: 'center'
      });
    }
  }, {
    key: 'sortByDisplayName',
    value: function sortByDisplayName(driverEta1, driverEta2) {
      var displayName1 = driverEta1[0].toLowerCase();
      var displayName2 = driverEta2[0].toLowerCase();

      if (displayName1 < displayName2) {
        return -1;
      }
      if (displayName1 > displayName2) {
        return 1;
      }

      return 0;
    }
  }]);

  return DriverEtasTableBuilder;
}();

exports.default = DriverEtasTableBuilder;