'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeEmoji = require('node-emoji');

var _nodeEmoji2 = _interopRequireDefault(_nodeEmoji);

var _immutable = require('immutable');

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _DistanceCalculator = require('../../calculators/DistanceCalculator');

var _DistanceCalculator2 = _interopRequireDefault(_DistanceCalculator);

var _NearbyDriverFormatter = require('../formatters/NearbyDriverFormatter');

var _NearbyDriverFormatter2 = _interopRequireDefault(_NearbyDriverFormatter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NearbyDriversTableBuilder = function () {
  function NearbyDriversTableBuilder() {
    _classCallCheck(this, NearbyDriversTableBuilder);
  }

  _createClass(NearbyDriversTableBuilder, null, [{
    key: 'build',
    value: function build(nearbyDrivers) {
      var table = NearbyDriversTableBuilder.buildInitialTable(nearbyDrivers.location.name);

      var nearbyDriverRows = nearbyDrivers.nearbyDrivers.map(function (nearbyDriver) {
        return NearbyDriversTableBuilder.buildNearbyDriverRow(nearbyDriver);
      });

      nearbyDriverRows = nearbyDriverRows.sort(NearbyDriversTableBuilder.sortByRideType);

      nearbyDriverRows.forEach(function (nearbyDriverRow) {
        table.push(nearbyDriverRow);
      });

      return table.toString();
    }
  }, {
    key: 'getTableHeaders',
    value: function getTableHeaders() {
      return _immutable.List.of(_nodeEmoji2.default.get('red_car'), _nodeEmoji2.default.get('straight_ruler'));
    }
  }, {
    key: 'buildInitialTable',
    value: function buildInitialTable(locationName) {
      var table = new _cliTable2.default();
      table.push([{
        colSpan: 2,
        content: _nodeEmoji2.default.get('round_pushpin') + ' ' + locationName,
        hAlign: 'center'
      }]);
      var formattedHeaders = (0, _immutable.List)(NearbyDriversTableBuilder.getTableHeaders().map(function (header) {
        return (0, _immutable.Map)({ content: header, hAlign: 'center' });
      }));
      table.push(formattedHeaders.toJS());
      return table;
    }
  }, {
    key: 'buildNearbyDriverRow',
    value: function buildNearbyDriverRow(nearbyDriver) {
      return [_NearbyDriverFormatter2.default.formatRideType(nearbyDriver.rideType), NearbyDriversTableBuilder.buildDistance(_NearbyDriverFormatter2.default.formatDistance(nearbyDriver.distance)).toJS()];
    }
  }, {
    key: 'buildDistance',
    value: function buildDistance(distance) {
      return (0, _immutable.Map)({
        content: distance,
        hAlign: 'center'
      });
    }
  }, {
    key: 'sortByRideType',
    value: function sortByRideType(nearbyDriver1, nearbyDriver2) {
      var displayName1 = nearbyDriver1[0].toLowerCase();
      var displayName2 = nearbyDriver2[0].toLowerCase();

      if (displayName1 < displayName2) {
        return -1;
      }
      if (displayName1 > displayName2) {
        return 1;
      }

      return 0;
    }
  }]);

  return NearbyDriversTableBuilder;
}();

exports.default = NearbyDriversTableBuilder;