'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeEmoji = require('node-emoji');

var _nodeEmoji2 = _interopRequireDefault(_nodeEmoji);

var _immutable = require('immutable');

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RideTypesTableBuilder = function () {
  function RideTypesTableBuilder() {
    _classCallCheck(this, RideTypesTableBuilder);
  }

  _createClass(RideTypesTableBuilder, null, [{
    key: 'build',
    value: function build(rideTypes) {
      var table = RideTypesTableBuilder.buildInitialTable(rideTypes.location.name);

      var rideTypeRows = rideTypes.rideTypes.map(function (rideType) {
        return RideTypesTableBuilder.buildRideTypeRow(rideType);
      });

      rideTypeRows = rideTypeRows.sort(RideTypesTableBuilder.sortByDisplayName);

      rideTypeRows.forEach(function (rideTypeRow) {
        table.push(rideTypeRow);
      });

      return table.toString();
    }
  }, {
    key: 'getTableHeaders',
    value: function getTableHeaders() {
      return _immutable.List.of(_nodeEmoji2.default.get('red_car'), _nodeEmoji2.default.get('seat'));
    }
  }, {
    key: 'buildInitialTable',
    value: function buildInitialTable(locationName) {
      var table = new _cliTable2.default();
      table.push([{
        colSpan: 2,
        content: _nodeEmoji2.default.get('round_pushpin') + ' ' + locationName,
        hAlign: 'center'
      }]);
      var formattedHeaders = (0, _immutable.List)(RideTypesTableBuilder.getTableHeaders().map(function (header) {
        return (0, _immutable.Map)({ content: header, hAlign: 'center' });
      }));
      table.push(formattedHeaders.toJS());
      return table;
    }
  }, {
    key: 'buildRideTypeRow',
    value: function buildRideTypeRow(rideType) {
      return [rideType.displayName, RideTypesTableBuilder.buildSeats(rideType.seats).toJS()];
    }
  }, {
    key: 'buildSeats',
    value: function buildSeats(seats) {
      return (0, _immutable.Map)({
        content: seats,
        hAlign: 'center'
      });
    }
  }, {
    key: 'sortByDisplayName',
    value: function sortByDisplayName(rideType1, rideType2) {
      var displayName1 = rideType1[0].toLowerCase();
      var displayName2 = rideType2[0].toLowerCase();

      if (displayName1 < displayName2) {
        return -1;
      }
      if (displayName1 > displayName2) {
        return 1;
      }

      return 0;
    }
  }]);

  return RideTypesTableBuilder;
}();

exports.default = RideTypesTableBuilder;