'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _currencySymbolMap = require('currency-symbol-map');

var _currencySymbolMap2 = _interopRequireDefault(_currencySymbolMap);

var _DistanceUnit = require('../../../data/DistanceUnit');

var _DistanceUnit2 = _interopRequireDefault(_DistanceUnit);

var _DistanceConverter = require('../../converters/DistanceConverter');

var _DistanceConverter2 = _interopRequireDefault(_DistanceConverter);

var _DurationConverter = require('../../converters/DurationConverter');

var _DurationConverter2 = _interopRequireDefault(_DurationConverter);

var _Utilities = require('../../../Utilities');

var _Utilities2 = _interopRequireDefault(_Utilities);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CostEstimateFormatter = function () {
  function CostEstimateFormatter() {
    _classCallCheck(this, CostEstimateFormatter);
  }

  _createClass(CostEstimateFormatter, null, [{
    key: 'formatRange',
    value: function formatRange(range) {
      var currencySymbol = (0, _currencySymbolMap2.default)(range.currencyCode);
      return '' + currencySymbol + range.min / 100 + ' - ' + currencySymbol + range.max / 100;
    }
  }, {
    key: 'formatDistance',
    value: function formatDistance(distance) {
      // 2 decimal places
      var roundedDistanceValue = Math.round(distance.value * 100) / 100;
      return roundedDistanceValue + ' ' + CostEstimateFormatter.getDistanceUnitAbbreviation(distance.unit) + '.';
    }
  }, {
    key: 'formatDuration',
    value: function formatDuration(duration) {
      // TODO @jbradley Utilities currently formats time in seconds - build better formatting logic
      // const durationInSeconds = DurationConverter.convert(duration, TimeUnit.SECOND);
      // return Utilities.generateFormattedTime(durationInSeconds.length);
      return _Utilities2.default.generateFormattedTime(duration.length);
    }
  }, {
    key: 'getDistanceUnitAbbreviation',
    value: function getDistanceUnitAbbreviation(unit) {
      switch (unit) {
        case _DistanceUnit2.default.MILE:
          {
            return 'mi';
          }

        case _DistanceUnit2.default.KILOMETER:
          {
            return 'km';
          }

        default:
          {
            throw new TypeError('Unexpected distance unit');
          }
      }
    }
  }]);

  return CostEstimateFormatter;
}();

exports.default = CostEstimateFormatter;