'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _DistanceUnit = require('../../../data/DistanceUnit');

var _DistanceUnit2 = _interopRequireDefault(_DistanceUnit);

var _DistanceConverter = require('../../converters/DistanceConverter');

var _DistanceConverter2 = _interopRequireDefault(_DistanceConverter);

var _DurationConverter = require('../../converters/DurationConverter');

var _DurationConverter2 = _interopRequireDefault(_DurationConverter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NearbyDriverFormatter = function () {
  function NearbyDriverFormatter() {
    _classCallCheck(this, NearbyDriverFormatter);
  }

  _createClass(NearbyDriverFormatter, null, [{
    key: 'formatRideType',
    value: function formatRideType(rideType) {
      rideType = rideType.split('_');
      rideType.forEach(function (word, index, array) {
        array[index] = word.charAt(0).toUpperCase() + word.slice(1);
      });
      return rideType.join(' ');
    }
  }, {
    key: 'formatDistance',
    value: function formatDistance(distance) {
      // 2 decimal places
      var roundedDistanceValue = Math.round(distance.value * 100) / 100;
      return roundedDistanceValue + ' ' + NearbyDriverFormatter.getDistanceUnitAbbreviation(distance.unit) + '.';
    }
  }, {
    key: 'getDistanceUnitAbbreviation',
    value: function getDistanceUnitAbbreviation(unit) {
      switch (unit) {
        case _DistanceUnit2.default.MILE:
          {
            return 'mi';
          }

        case _DistanceUnit2.default.KILOMETER:
          {
            return 'km';
          }

        default:
          {
            throw new TypeError('Unexpected distance unit');
          }
      }
    }
  }]);

  return NearbyDriverFormatter;
}();

exports.default = NearbyDriverFormatter;