'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _Coordinate = require('../../data/Coordinate');

var _Coordinate2 = _interopRequireDefault(_Coordinate);

var _Location = require('../../data/Location');

var _Location2 = _interopRequireDefault(_Location);

var _Utilities = require('../../Utilities');

var _Utilities2 = _interopRequireDefault(_Utilities);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CurrentLocationTranslator = function () {
  function CurrentLocationTranslator() {
    _classCallCheck(this, CurrentLocationTranslator);
  }

  _createClass(CurrentLocationTranslator, null, [{
    key: 'translate',
    value: function translate(json) {

      if (!('latitude' in json)) {
        throw new ReferenceError('expected latitude field');
      }

      var latitude = json['latitude'];

      if (typeof latitude !== 'number') {
        throw new TypeError('expected latitude to be a number');
      }

      if (!('longitude' in json)) {
        throw new ReferenceError('expected longitude field');
      }

      var longitude = json['longitude'];

      if (typeof longitude !== 'number') {
        throw new TypeError('expected longitude to be a number');
      }

      // Uncomment below for showing current location address
      // return new Coordinate({
      //   latitude: latitude,
      //   longitude: longitude,
      // });

      return new _Location2.default({
        name: 'Current Location',
        coordinate: new _Coordinate2.default({
          latitude: latitude,
          longitude: longitude
        })
      });
    }
  }]);

  return CurrentLocationTranslator;
}();

exports.default = CurrentLocationTranslator;