'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _Duration = require('../../data/Duration');

var _Duration2 = _interopRequireDefault(_Duration);

var _TimeUnit = require('../../data/TimeUnit');

var _TimeUnit2 = _interopRequireDefault(_TimeUnit);

var _DriverEta = require('../../data/DriverEta');

var _DriverEta2 = _interopRequireDefault(_DriverEta);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DriverEtasTranslator = function () {
  function DriverEtasTranslator() {
    _classCallCheck(this, DriverEtasTranslator);
  }

  _createClass(DriverEtasTranslator, null, [{
    key: 'translate',
    value: function translate(response) {
      if (!('eta_estimates' in response)) {
        throw new ReferenceError('expected eta_estimates field');
      }

      var etaEstimates = response.eta_estimates;

      if (!Array.isArray(etaEstimates)) {
        throw new TypeError('expected eta_estimates to be an array');
      }

      return (0, _immutable.List)(etaEstimates.map(function (etaEstimate) {
        return DriverEtasTranslator.translateEtaEstimate(etaEstimate);
      }));
    }
  }, {
    key: 'translateEtaEstimate',
    value: function translateEtaEstimate(etaEstimate) {
      if (!('display_name' in etaEstimate)) {
        throw new ReferenceError('expected display_name field');
      }

      if (!('eta_seconds' in etaEstimate)) {
        throw new ReferenceError('expected eta_seconds field');
      }

      if (!('is_valid_estimate' in etaEstimate)) {
        throw new ReferenceError('expected is_valid_estimate field');
      }

      var displayName = etaEstimate.display_name;

      if (typeof displayName !== 'string') {
        throw new TypeError('expected display_name to be a string');
      }

      var etaSeconds = etaEstimate.eta_seconds;

      if (!Number.isInteger(etaSeconds)) {
        throw new TypeError('expected eta_seconds to be an integer');
      }

      var isValidEstimate = etaEstimate.is_valid_estimate;

      if (!(typeof isValidEstimate === 'undefined' ? 'undefined' : _typeof(isValidEstimate)) === 'boolean') {
        throw new TypeError('expected is_valid_estimate to be an boolean');
      }

      return new _DriverEta2.default({
        displayName: displayName,
        etaSeconds: new _Duration2.default({
          length: etaSeconds,
          unit: _TimeUnit2.default.SECOND
        }),
        isValidEstimate: isValidEstimate
      });
    }
  }]);

  return DriverEtasTranslator;
}();

exports.default = DriverEtasTranslator;