'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _RideType = require('../../data/RideType');

var _RideType2 = _interopRequireDefault(_RideType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RideTypesTranslator = function () {
  function RideTypesTranslator() {
    _classCallCheck(this, RideTypesTranslator);
  }

  _createClass(RideTypesTranslator, null, [{
    key: 'translate',
    value: function translate(response) {

      if (!('ride_types' in response)) {
        throw new ReferenceError('expected ride_types field');
      }

      var rideTypes = response.ride_types;

      if (!Array.isArray(rideTypes)) {
        throw new TypeError('expected ride_types to be an array');
      }

      return (0, _immutable.List)(rideTypes.map(function (rideType) {
        return RideTypesTranslator.translateRideType(rideType);
      }));
    }
  }, {
    key: 'translateRideType',
    value: function translateRideType(rideType) {

      if (!('display_name' in rideType)) {
        throw new ReferenceError('expected display_name field');
      }

      if (!('seats' in rideType)) {
        throw new ReferenceError('expected seats field');
      }

      var displayName = rideType.display_name;

      if (typeof displayName !== 'string') {
        throw new TypeError('expected display_name to be a string');
      }

      var seats = rideType.seats;

      if (!Number.isInteger(seats)) {
        throw new TypeError('expected seats to be an integer');
      }

      return new _RideType2.default({
        displayName: displayName,
        seats: seats
      });
    }
  }]);

  return RideTypesTranslator;
}();

exports.default = RideTypesTranslator;